moveaid/urls.py
# This file is part of the MoveAid project.
# Copyright (C) 2021 Marco Marinello <mmarinello@unibz.it>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

"""moveaid URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.1/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""

from django.conf import settings
from django.contrib import admin
from django.urls import path, include
from rest_framework.authtoken import views as Rviews
from django.conf.urls import url

from moveaid import views
from moveart import views as RTviews

urlpatterns = [
    path('admin/', admin.site.urls),
    path('api/auth/token', Rviews.obtain_auth_token),
    # path('api/web/', include('webapi.urls')),
    path('api/sms/', include('sms_office.urls')),
    path('api/companion/position/submit', RTviews.VehiclePositionSubmission.as_view()),
    path('api/companion/position/last', RTviews.LastUserPosition.as_view()),
    path('api/companion/verify', RTviews.VerifyToken.as_view()),
    path('accounts/', include('django.contrib.auth.urls')),
    path('', views.HomeView.as_view(), name="home"),
    path('locations/ajax_list', views.LocationsAjaxQuery.as_view(), name='locations-ajax-list'),
    path('addresses/ajax_search', views.AddressAjaxQuery.as_view(), name='addresses-ajax-search'),
    path('operators/', include(('operators.urls', 'operators'), 'operators')),
    url(r'^signup/$', views.Signup.as_view(), name='signup'),
]

if settings.DEBUG:
    urlpatterns.append(path('api/auth/', include('rest_framework.urls', namespace='rest_framework')))

operators/urls.py
# This file is part of the MoveAid project.
# Copyright (C) 2021 Marco Marinello <marco.marinello@lugbz.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

from django.urls import path

from operators import views

urlpatterns = [
    path('', views.DashboardView.as_view(), name="dashboard"),
    path('reservation/new', views.NewReservationView.as_view(), name='new-reservation'),
    path('reservation/new/', views.NewReservationView.as_view(), name='new-reservation-from-trip-leg'),
    path('reservation/new/<int:tlid>', views.NewReservationView.as_view(), name='new-reservation-from-trip-leg'),
    path('reservation/<int:pk>', views.EditReservationView.as_view(), name='edit-reservation'),
    path('reservation/', views.EditReservationView.as_view(), name='edit-reservation'),
    path('reservation/trip_leg/delete/<int:pk>', views.DeleteTripLegView.as_view(), name='delete-trip-leg'),
    path('reservation/trip_leg/delete/', views.DeleteTripLegView.as_view(), name='delete-trip-leg'),
    path('reservation/ajax_query', views.ReservationsQuery.as_view(), name='reservation-ajax-query'),
    path('senior/ajax_query', views.SeniorQuery.as_view(), name='senior-ajax-query'),
    path('location/', views.LocationsList.as_view(), name='locations-list'),
    path('location/problematic/', views.ProblematicLocationsList.as_view(), name='problematic-locations-list'),
    path(
        'location/problematic/<int:pk>/edit',
        views.EditProblematicLocationView.as_view(),
        name='edit-problematic-locations-list'
    ),
    path('location/new', views.NewLocationView.as_view(), name='new-location'),
    path('location/<int:pk>/edit', views.EditLocationView.as_view(), name='edit-location'),
    path('location/<int:pk>/delete', views.DeleteLocationView.as_view(), name='delete-location'),
    path('senior/', views.SeniorSearchView.as_view(), name='seniors'),
    path('senior/new', views.NewSeniorView.as_view(), name='new-senior'),
    path('senior/<int:pk>/edit', views.EditSeniorView.as_view(), name='edit-senior'),
    path('vehicles/', views.VehiclesList.as_view(), name='vehicles-list'),
    path('vehicles/new', views.NewVehicleView.as_view(), name='new-vehicle'),
    path('vehicles/<int:pk>/edit', views.EditVehicleView.as_view(), name='edit-vehicle'),
    path('vehicles/<int:pk>/delete', views.DeleteVehicleView.as_view(), name='delete-vehicle'),
    path('vehicles/pair', views.VehiclePairDevice.as_view(), name='pair-vehicle'),
    path('drivers_shifts', views.DriversShiftsList.as_view(), name='drivers-shifts'),
    path('drivers_shifts/new', views.DriverShiftCreation.as_view(), name='driver-shift-new'),
    path('drivers_shifts/old', views.DriversShiftsOldList.as_view(), name='drivers-shifts-old'),
    path('drivers_shifts/<int:pk>', views.DriverShiftUpdate.as_view(), name='driver-shift-update'),
    path('drivers_shifts/<int:pk>/delete', views.DriverShiftDelete.as_view(), name='driver-shift-delete'),
    path('drivers_shifts/<int:pk>/print', views.ManyTripSheetPrint.as_view(), name='driver-shift-print-A5'),
    path('driver/ajax_query', views.DriverQuery.as_view(), name='driver-ajax-query'),
    path('vehicle/ajax_query', views.VehicleQuery.as_view(), name='vehicle-ajax-query'),
    path('reservation/trip_leg/assign', views.TripLegDriverAssociation.as_view(), name='trip-leg-driver-association'),
    path('reservation/trip_leg/deassign', views.TripLegDriverDeassociation.as_view(),
         name='trip-leg-driver-deassociation'),
    path('reservation/trip_leg/print/', views.TripSheetPrint.as_view(), name='trip-sheet-print'),
    path('reservation/trip_leg/print/<int:pk>', views.TripSheetPrint.as_view(), name='trip-sheet-print'),
    path('vehicles_rt/', views.VehiclesRealTime.as_view(), name='vehicles-rt'),
    path('vehicles_rt/ajax', views.VehiclesRealTimeAjax.as_view(), name='vehicles-rt-ajax'),
    path('info', views.PlatformInfo.as_view(), name='info'),
]

webapi/urls.py
# This file is part of the MoveAid project.
# Copyright (C) 2021 Marco Marinello <mmarinello@unibz.it>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

from django.urls import path
from webapi import views

urlpatterns = [
    path('csrf', views.authentication.GetCSRFTokenView.as_view()),
    path('login', views.authentication.LoginView.as_view()),
    path('login/logout', views.authentication.LogoutView.as_view()),
    path('login/is_authenticated', views.authentication.IsAuthenticatedView.as_view()),
    path('login/set_role', views.authentication.SetRoleView.as_view()),
    path('login/get_role', views.authentication.GetRoleView.as_view()),
    path('login/get_roles', views.authentication.GetAllUserRolesView.as_view()),
]
urlpatterns += views.router.urls

moveart/models.py
# This file is part of the MoveAid project.
# Copyright (C) 2023 Marco Marinello <contact-nohuman@marinello.bz.it>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

from django.db import models
from django.utils.translation import ugettext_lazy as _


class VehiclePosition(models.Model):
    vehicle = models.ForeignKey("moveaid.Vehicle", on_delete=models.PROTECT, verbose_name=_("vehicle"))

    lat = models.DecimalField(
        max_digits=9,
        decimal_places=6,
        null=True,
        blank=True,
        verbose_name=_("latitude")
    )

    lng = models.DecimalField(
        max_digits=9,
        decimal_places=6,
        null=True,
        blank=True,
        verbose_name=_("longitude")
    )

    timestamp = models.DateTimeField(auto_now_add=True)

    class Meta:
        verbose_name = _("Vehicle position")
        verbose_name_plural = _("Vehicles positions")
        ordering = ('-timestamp', 'vehicle')

seniors/views.py
from django.shortcuts import render

# Create your views here.

operators/templates/operators/base.html
{% extends "base.html" %}{% load i18n %}
{% block nav %}
<li class="nav-item">
    <a class="nav-link active" aria-current="page" href="{% url 'operators:dashboard' %}">
        <i class="fas fa-tachometer-alt"></i>
        {% trans "Dashboard" %}
    </a>
</li>
<li class="nav-item">
    <a class="nav-link active" aria-current="page" href="{% url 'operators:seniors' %}">
        <i class="fas fa-users"></i>
        {% trans "Seniors" %}
    </a>
</li>
<li class="nav-item">
    <a class="nav-link active" aria-current="page" href="{% url 'operators:locations-list' %}">
        <i class="fas fa-map-marked"></i>
        {% trans "Locations" %}
    </a>
</li>
<li class="nav-item">
    <a class="nav-link active" aria-current="page" href="{% url 'operators:drivers-shifts' %}">
        <i class="fas fa-clipboard-check"></i>
        {% trans "Drivers shifts" %}
    </a>
</li>
<li class="nav-item">
    <a class="nav-link active" aria-current="page" href="{% url 'operators:vehicles-list' %}">
        <i class="fas fa-car"></i>
        {% trans "Vehicles" %}
    </a>
</li>
<li class="nav-item">
    <a class="nav-link active" aria-current="page" href="{% url 'operators:vehicles-rt' %}">
        <i class="fas fa-globe-europe"></i>
        {% trans "Real time map" %}
    </a>
</li>
<li class="nav-item">
    <a class="nav-link active" aria-current="page" href="{% url 'operators:info' %}">
        <i class="fas fa-info-circle"></i>
        {% trans "Info" %}
    </a>
</li>
{% endblock %}

operators/templates/operators/driver_shift_delete.html
{% extends "operators/base.html" %}{% load i18n static %}
{% block title %}{% trans "Delete shift" %} {{ object }}{% endblock %}
{% block content %}
<div class="page-header mb-4">
    <h1>{% trans "Delete shift" %} {{ object }}?</h1>
</div>

{% if object.tripleg_set.all %}
<div class="alert alert-warning row mb-4">
    <div class="col-lg-2 text-center">
        <i class="fas fa-exclamation-triangle fa-3x"></i>
    </div>
    <div class="col-lg-10">
        {% blocktrans %}Warning: it's impossible to delete this driver shift because one or more trips have already been assigned.{% endblocktrans %}
    </div>
</div>
<a href="{% url 'operators:drivers-shifts' %}" class="btn btn-lg btn-primary">{% trans "Undo and go back" %}</a>
{% else %}
<form action="" method="post">
    {% csrf_token %}
    <a href="{% url 'operators:drivers-shifts' %}" class="btn btn-lg btn-primary">{% trans "Undo and go back" %}</a>
    <button type="submit" role="button" class="btn btn-lg btn-danger">{% trans "Delete" %}</button>
</form>
{% endif %}

{% endblock %}

operators/templates/operators/driver_shift_edit.html
{% extends "operators/base.html" %}{% load i18n static %}
{% block title %}{% if form.driver.value %}{% trans "Editing driver shift" %}{% else %}{% trans "Add driver shift" %}{% endif %}{% endblock %}
{% block extrahead %}
<link href="{% static 'select2/css/select2.min.css' %}" rel="stylesheet" />
<script src="{% static 'select2/js/select2.min.js' %}"></script>
{% endblock %}
{% block content %}

<div class="page-header mb-4">
    <h1>{% if form.driver.value %}{% trans "Editing driver shift" %}{% else %}{% trans "Add driver shift" %}{% endif %}</h1>
</div>

<div class="row">
    <div class="col-lg-12">
        {% if form.errors %}
        <div class="alert alert-danger alert-dismissible fade show mt-3" role="alert">
            <strong>{% trans 'Errors!' %}</strong> {% trans 'Please check the following fields.' %}
            <ul class="list-group list-group-flush mt-2">
            {% for field, errors in form.errors.items %}
                {% for error in errors %}
                <li class="list-group-item bg-transparent"><strong>&bull;</strong>&nbsp;{{ error }}</li>
                {% endfor %}
            {% endfor %}
            </ul>
            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
        </div>
        {% endif %}
        <form action="" method="post" id="id_form">
            {% csrf_token %}
            {{ form.as_p }}
            <button role="button" type="submit" class="btn btn-lg btn-success float-end">
                <i class="fas fa-save"></i> &nbsp;
                {% trans "Save" %}
            </button>
        </form>
    </div>
</div>

<script type="text/javascript">
    $(document).ready(function() {
        $("#id_driver").select2();
        $("#id_vehicle").select2();

        $('#id_time_start').val("{{ form.time_start.value.isoformat }}");
        $('#id_time_end').val("{{ form.time_end.value.isoformat }}");
    });
</script>

{% endblock %}

operators/templates/operators/drivers_shifts.html
{% extends "operators/base.html" %}{% load i18n l10n static %}{% get_current_language as LANGUAGE_CODE %}
{% block title %}{{ title }}{% endblock %}
{% block extrahead %}
<link href="{% static 'select2/css/select2.min.css' %}" rel="stylesheet" />
<script src="{% static 'select2/js/select2.min.js' %}"></script>
<link rel="stylesheet" type="text/css" href="{% static 'datatables1/datatables.min.css' %}"/>
<script type="text/javascript" src="{% static 'datatables1/datatables.min.js' %}"></script>
{% endblock %}
{% block content %}

<div class="page-header row mb-4">
    <div class="col-lg-8">
        <h1>{{ title }}</h1>
    </div>
    <div class="col-lg-4 text-end">
        <a class="btn btn-lg btn-success" href="{% url 'operators:driver-shift-new' %}">
            <i class="fas fa-plus"></i>
            &nbsp; {% trans "Create shift" %}
        </a>
    </div>
</div>

<table class="table table-striped" id="table">
    <thead>
    <tr>
        <th>{% trans "Driver" %}</th>
        <th>{% trans "Shift Start Time" %}</th>
        <th>{% trans "Shift End Time" %}</th>
        <th></th>
        <th></th>
        <th></th>
    </tr>
    </thead>
    <tbody>
        {% for o in object_list %}
        <tr>
            <td>{{ o.driver.user.get_full_name|default:o.driver.user.username }}</td>
            <td data-order="{{ o.time_start.timestamp }}">{{ o.time_start|date:"D d/m/Y H:i" }}</td>
            <td data-order="{{ o.time_start.timestamp }}">{{ o.time_end|date:"D d/m/Y H:i" }}</td>
            <td>
                <a href="{% url 'operators:driver-shift-print-A5' pk=o.pk %}" target="_blank" class="btn btn-lg btn-primary">
                    <i class="fas fa-print"></i>
                </a>
            </td>
            <td>
                <a href="{% url 'operators:driver-shift-update' pk=o.pk %}" class="btn btn-lg btn-info">
                    <i class="fas fa-edit"></i>
                </a>
            </td>
            <td>
                <a href="{% url 'operators:driver-shift-delete' pk=o.pk %}" class="btn btn-lg btn-danger">
                    <i class="fas fa-trash"></i>
                </a>
            </td>
        </tr>
        {% endfor %}
    </tbody>
</table>

<script type="text/javascript">
    $(document).ready(function() {
        $("#table").dataTable({
            order: [["1", "asc"]],
            language: {url: "{% static 'datatables1/i18n/'|add:LANGUAGE_CODE|add:"_"|add:LANGUAGE_CODE|add:'.json' %}"}
        });
    });
</script>

{% endblock %}

operators/templates/operators/info.html
{% extends "operators/base.html" %}{% load i18n static %}
{% block title %}{% trans "Platform information" %}{% endblock %}
{% block content %}
<div class="page-header mb-4">
    <h1>{% trans "Platform information" %}</h1>
</div>


MoveAid {% trans "version" %} {{ INFO_SYSTEM_VERSION }} ({{ INFO_SYSTEM_GIT_REVISION }})<br>
{% trans "Instance of" %} {{ INFO_SYSTEM_INSTANCE_NAME }}

{% endblock %}

operators/templates/operators/location_delete.html
{% extends "operators/base.html" %}{% load i18n static %}
{% block title %}{% trans "Delete location" %} {{ object.name }}{% endblock %}
{% block content %}
<div class="page-header mb-4">
    <h1>{% trans "Delete location" %} {{ object.name }}?</h1>
</div>

<div class="alert alert-warning row mb-4">
    <div class="col-lg-2 text-center">
        <i class="fas fa-exclamation-triangle fa-3x"></i>
    </div>
    <div class="col-lg-10">
        {% blocktrans %}Warning: it's impossible to delete a location if one or more trip stages are using it as
        destination. Use this function only if the location has been created by mistake and never used.{% endblocktrans %}
    </div>
</div>

<form action="" method="post">
    {% csrf_token %}
    <a href="{% url 'operators:locations-list' %}" class="btn btn-lg btn-primary">{% trans "Undo and go back" %}</a>
    <button type="submit" role="button" class="btn btn-lg btn-danger">{% trans "Delete" %}</button>
</form>

{% endblock %}

operators/templates/operators/location_new.html
{% extends "operators/base.html" %}{% load i18n static %}
{% block title %}
    {% if problematic %}{% trans "Fixing" %} {{ form.address.value }}
    {% elif form.name.value %}{% trans "Editing" %} "{{ form.name.value }}"
    {% else %}{% trans "Add location" %}{% endif %}
{% endblock %}
{% block extrahead %}
<link rel="stylesheet" href="{% static 'leaflet1/leaflet.css' %}" />
<script src="{% static 'leaflet1/leaflet.js' %}"></script>
<link href="{% static 'select2/css/select2.min.css' %}" rel="stylesheet" />
<script src="{% static 'select2/js/select2.min.js' %}"></script>
{% endblock %}
{% block content %}

<div class="page-header mb-4">
    <h1>
        {% if problematic %}{% trans "Fixing" %} {{ form.address.value }}
        {% elif form.name.value %}{% trans "Editing" %} "{{ form.name.value }}"
        {% else %}{% trans "Add location" %}{% endif %}
    </h1>
</div>

<div class="row">
    <div class="col-lg-4">
        {{ form.errors }}
        <form action="" method="post">
            {% csrf_token %}
            <div class="form-group mb-3">
                {{ form.name.label }}:
                {{ form.name }}
            </div>
            <div class="form-group mb-3">
                <label for="id_address">{% trans "Address" %}:</label>
                <select name="address" id="id_address" class="form-control">
                    {% if form.address.value %}<option value="{{ form.address.value }}" selected>{{ form.address.value }}</option>{% endif %}
                </select>
            </div>
            <div class="row">
                <div class="col-lg-6">
                    {{ form.lat }}
                </div>
                <div class="col-lg-6">
                    {{ form.lng }}
                </div>
            </div>
            <div class="mt-4 text-end">
                <button role="button" type="submit" class="btn btn-lg btn-success">
                    <i class="fas fa-save"></i> &nbsp; {% trans "Save" %}
                </button>
            </div>
        </form>
    </div>
    <div class="col-lg-8">
        <div id="map" style="height: 600px;"></div>
    </div>
</div>

<script type="text/javascript">
    $(document).ready(function() {
        // map configuration
        window.map = L.map('map').setView([46.497523, 11.352499], 13);
        window.layergroup = L.layerGroup().addTo(window.map);
        var tiles = L.tileLayer('//{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            maxZoom: 18,
            minZoom: 2,
            attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors'
        }).addTo(window.map);
        {% if form.address.value and form.lat.value and form.lng.value %}
            L.marker([{{ form.lat.value|safe }}, {{ form.lng.value|safe }}]).addTo(window.layergroup);
            window.map.setView([{{ form.lat.value|safe }}, {{ form.lng.value|safe }}], 15);
        {% endif %}

        // address search via OSM Nominatim
        $('#id_address').select2({
            ajax: {
                url: "{% url 'addresses-ajax-search' %}",
                dataType: "json",
                delay: 400,
                type: "POST",
                data: function (params) {return {"q": params.term, "csrfmiddlewaretoken": "{{ csrf_token }}"};},
                processResults: function (data, params) {return {results: data}}
            },
            placeholder: "{% trans 'Start typing the address' %}",
            minimumInputLength: 6,
            templateResult: function (address) {return address.display_name || "{% trans 'Searching...' %}";}
        }).on("select2:select", function (e) {
            window.address = e.params.data;
            window.layergroup.clearLayers();
            L.marker([window.address.lat, window.address.lon]).addTo(window.layergroup);
            window.map.setView([window.address.lat, window.address.lon]);
            $("#id_lat").val(window.address.lat);
            $("#id_lng").val(window.address.lon);
        });
    });
</script>

{% endblock %}

operators/templates/operators/many_trip_sheet_A5.html
{% for trip_leg in trips %}
{% include "operators/trip_sheet_A5.html" with trip_leg=trip_leg logo=logo %}
<div class="mt-5"></div>
{% endfor %}

operators/templates/operators/seniors.html
{% extends "operators/base.html" %}{% load i18n static %}
{% block title %}{% trans "Seniors overview" %}{% endblock %}
{% block extrahead %}
<link href="{% static 'select2/css/select2.min.css' %}" rel="stylesheet" />
<script src="{% static 'select2/js/select2.min.js' %}"></script>
{% endblock %}
{% block content %}
<div class="page-header row mb-4">
    <div class="col-lg-8">
        <h1>{% trans "Seniors" %}</h1>
    </div>
    <div class="col-lg-4 text-end">
        <a class="btn btn-lg btn-success" href="{% url 'operators:new-senior' %}">
            <i class="fas fa-plus"></i>
            &nbsp; {% trans "Add senior" %}
        </a>
    </div>
</div>


<div class="row mt-5">
    <h2 class="col-lg-12 text-center">
        {% blocktrans %}There are<br></brt><b>{{ total_members }}</b><br>members in the application divided as follows{% endblocktrans %}
    </h2>
    {% for i in organization_members %}
    <h3 class="col-lg-{{ factor }} text-center border border-secondary p-3">
        {{ i.0 }}<br>{{ i.1 }}
    </h3>
    {% endfor %}
</div>

<select id="senior-ajax" class="form-control"></select>


<script type="text/javascript">
    $(document).ready(function() {
        $('#senior-ajax').select2({
            ajax: {
                url: "{% url 'operators:senior-ajax-query' %}",
                type: "POST",
                dataType: "json",
                delay: 150,
                data: function (params) {return {"q": params.term, "csrfmiddlewaretoken": "{{ csrf_token }}"};},
                processResults: function (data, params) {return {results: data}}
            },
            placeholder: "{% trans 'Start typing the card no. or the last name' %}",
            minimumInputLength: 2,
            templateResult: function (senior) {
                if (senior.fullname == undefined) return $("");
                var out = $(
                    "<div class='select2-result'><h4><b><i class='fas fa-user'></i>&nbsp;" + senior.fullname +
                    "</b></h4><i class='fas fa-id-card'></i>&nbsp;" + (senior.member_card_issuer || "{% trans 'not registered' %}") + " " +
                    (senior.member_card_number || "") + "<br><i class='fas fa-phone'></i>&nbsp;" +
                    (senior.phone_number || "{% trans 'not registered' %}") + "&nbsp;<i class='fas fa-envelope'></i>&nbsp;" +
                    (senior.email || "{% trans 'not registered' %}") + "<br><i class='fas fa-map-marked-alt'></i>&nbsp;" +
                    senior.home.address + "</div>"
                );
                return out;
            },
            templateSelection: function (senior) {return senior.fullname || "{% trans 'Start typing the card no. or the last name' %}";}
        }).on("select2:select", function (e) {
            location.href = '' + e.params.data.id + '/edit';
        });
    });
</script>
{% endblock %}

operators/templates/operators/vehicle_new.html
{% extends "operators/base.html" %}{% load i18n static %}
{% block title %}{% if object %}{% trans "Editing" %} {{ object.user.get_full_name }}{% else %}{% trans "Add new senior" %}{% endif %}{% endblock %}
{% block extrahead %}
<link rel="stylesheet" href="{% static 'leaflet1/leaflet.css' %}" />
<script src="{% static 'leaflet1/leaflet.js' %}"></script>
<link href="{% static 'select2/css/select2.min.css' %}" rel="stylesheet" />
<script src="{% static 'select2/js/select2.min.js' %}"></script>
{% endblock %}
{% block content %}

<div class="page-header mb-4">
    <h1>{% if object %}{% trans "Editing" %} {{ object.plate_number }}{% else %}{% trans "Add new vehicle" %}{% endif %}</h1>
</div>

<div class="container">
    {{ form.errors }}
    <form action="" method="post">
        {% csrf_token %} {{ form.next_url }}
        <div class="form-group mb-3">
            {{ form.plate_number.errors }}
            {{ form.plate_number.label_tag }} {{ form.plate_number }}
        </div>
        <div class="form-group mb-3">
            {{ form.car_model.errors }}
            {{ form.car_model.label_tag }} {{ form.car_model }}
        </div>
        <div class="form-group mb-3">
            {{ form.owner.errors }}
            {{ form.owner.label_tag }} {{ form.owner }}
        </div>
        <div class="form-group mb-3">
            {{ form.user.errors }}
            {{ form.user.label_tag }} {{ form.user }}
        </div>
        <div class="form-group mb-3">
            {{ form.wheelchair.errors }}
            {{ form.wheelchair.label_tag }} {{ form.wheelchair }}
        </div>
        <div class="form-group mb-3">
            {{ form.active.errors }}
            {{ form.active.label_tag }} {{ form.active }}
        </div>
        <div class="mt-4 text-end">
            <button role="button" type="submit" class="btn btn-lg btn-success">
                <i class="fas fa-save"></i> &nbsp; {% trans "Save" %}
            </button>
        </div>
    </form>
</div>

<script>
$(document).ready(function() {
    $("#id_owner").select2();
    $("#id_user").select2();
});
</script>

{% endblock %}